(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('@triangular/font-awesome-icons', ['exports', '@angular/core', '@angular/common'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.triangular = global.triangular || {}, global.triangular['font-awesome-icons'] = {}), global.ng.core, global.ng.common));
}(this, (function (exports, i0, common) { 'use strict';

    var FontAwesomeIconsRegistry = /** @class */ (function () {
        function FontAwesomeIconsRegistry() {
            this.registry = new Map();
        }
        FontAwesomeIconsRegistry.prototype.registerIcons = function (icons) {
            var _this = this;
            icons.forEach(function (icon) { return _this.registry.set(icon.name, icon.data); });
        };
        FontAwesomeIconsRegistry.prototype.getIcon = function (iconName) {
            if (!this.registry.has(iconName)) {
                console.warn("We could not find the dinosaur Icon with the name " + iconName + ", did you add it to the Icon registry?");
            }
            return this.registry.get(iconName);
        };
        return FontAwesomeIconsRegistry;
    }());
    FontAwesomeIconsRegistry.ɵprov = i0.ɵɵdefineInjectable({ factory: function FontAwesomeIconsRegistry_Factory() { return new FontAwesomeIconsRegistry(); }, token: FontAwesomeIconsRegistry, providedIn: "root" });
    FontAwesomeIconsRegistry.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];

    var FontAwesomeIconComponent = /** @class */ (function () {
        function FontAwesomeIconComponent(element, iconsRegistry, document) {
            this.element = element;
            this.iconsRegistry = iconsRegistry;
            this.document = document;
        }
        Object.defineProperty(FontAwesomeIconComponent.prototype, "name", {
            set: function (iconName) {
                if (this.svgIcon) {
                    this.element.nativeElement.removeChild(this.svgIcon);
                }
                var svgData = this.iconsRegistry.getIcon(iconName);
                if (svgData) {
                    this.svgIcon = this.svgElementFromString(svgData);
                    this.element.nativeElement.appendChild(this.svgIcon);
                }
            },
            enumerable: false,
            configurable: true
        });
        FontAwesomeIconComponent.prototype.svgElementFromString = function (svgContent) {
            var div = this.document.createElement('DIV');
            if (div instanceof HTMLElement) {
                div.innerHTML = svgContent;
                return div.querySelector('svg') || this.document.createElementNS('http://www.w3.org/2000/svg', 'path');
            }
        };
        return FontAwesomeIconComponent;
    }());
    FontAwesomeIconComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'font-awesome-icon',
                    template: "<ng-content></ng-content>",
                    encapsulation: i0.ViewEncapsulation.None,
                    changeDetection: i0.ChangeDetectionStrategy.OnPush
                },] }
    ];
    FontAwesomeIconComponent.ctorParameters = function () { return [
        { type: i0.ElementRef },
        { type: FontAwesomeIconsRegistry },
        { type: undefined, decorators: [{ type: i0.Optional }, { type: i0.Inject, args: [common.DOCUMENT,] }] }
    ]; };
    FontAwesomeIconComponent.propDecorators = {
        name: [{ type: i0.Input }]
    };

    var FontAwesomeIconsModule = /** @class */ (function () {
        function FontAwesomeIconsModule() {
        }
        FontAwesomeIconsModule.forRoot = function () {
            return {
                ngModule: FontAwesomeIconsModule,
                providers: [
                    FontAwesomeIconsRegistry,
                ],
            };
        };
        return FontAwesomeIconsModule;
    }());
    FontAwesomeIconsModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: [FontAwesomeIconComponent],
                    imports: [],
                    exports: [FontAwesomeIconComponent]
                },] }
    ];

    /*
     * Public API Surface of the icons lib
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.FontAwesomeIconComponent = FontAwesomeIconComponent;
    exports.FontAwesomeIconsModule = FontAwesomeIconsModule;
    exports.FontAwesomeIconsRegistry = FontAwesomeIconsRegistry;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=triangular-font-awesome-icons.umd.js.map
